/*
 * HttpContextBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:40:19 EDT 02012.
 * 
 * See HttpContext.java for copyright information.
 */

package org.teatrove.teaapps.contexts;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing HttpContext. 
 *
 * @author Scott Jappinen
 */
public class HttpContextBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new HttpContextBeanInfo.
     */
    public HttpContextBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes HttpContext.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * HttpContext.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * HttpContext.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(HttpContext.class);
        
        bd.setName("HttpContext");
        bd.setDisplayName("HttpContext");
        bd.setShortDescription("");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // doGet 
        //
        paramTypes = new Class[5];
        paramDescriptors = new ParameterDescriptor[5];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("host");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("port");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("headers");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("timeout");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("doGet", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("doGet");
            md.setDisplayName("doGet");  
            
            mds.addElement(md);
        }            
           
        
        //
        // doPost 
        //
        paramTypes = new Class[6];
        paramDescriptors = new ParameterDescriptor[6];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("host");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("postData");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("port");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("headers");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("timeout");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("doPost", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("doPost");
            md.setDisplayName("doPost");  
            
            mds.addElement(md);
        }            
           
        
        //
        // doSecureGet 
        //
        paramTypes = new Class[5];
        paramDescriptors = new ParameterDescriptor[5];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("host");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("port");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("headers");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("timeout");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("doSecureGet", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("doSecureGet");
            md.setDisplayName("doSecureGet");  
            
            mds.addElement(md);
        }            
           
        
        //
        // doSecurePost 
        //
        paramTypes = new Class[6];
        paramDescriptors = new ParameterDescriptor[6];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("host");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("path");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("postData");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("port");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("headers");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = int.class; 
        pd = new ParameterDescriptor();
        pd.setName("timeout");
        pd.setDisplayName("int"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = HttpContext.class.getMethod("doSecurePost", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("doSecurePost");
            md.setDisplayName("doSecurePost");  
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[0];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}