/*
 * MapContextBeanInfo.java
 *
 * BeanDoc generated on Fri Mar 16 at 12:40:19 EDT 02012.
 * 
 * See MapContext.java for copyright information.
 */

package org.teatrove.teaapps.contexts;

import java.beans.*;
import java.lang.reflect.*;

import java.util.Vector;

/**
 * The BeanInfo class describing MapContext. 
 *
 * @author Scott Jappinen
 */
public class MapContextBeanInfo extends SimpleBeanInfo {

    /** BeanDescriptor returned by the <code>getBeanDescriptor</code> 
        method */
    private BeanDescriptor mBeanDescriptor;

    /** BeanInfo array returned by the <code>getAdditionalBeanInfo</code> 
        method */
    private BeanInfo[] mAdditionalBeanInfo;

    /** MethodDescriptor array returned by the 
        <code>getMethodDescriptors</code> method */
    private MethodDescriptor[] mMethodDescriptors;

    /** PropertyDescriptor array returned by the 
        <code>getPropertyDescriptors</code> method */
    private PropertyDescriptor[] mPropertyDescriptors;
    
    /** The index of the default property */
    private int mDefaultPropertyIndex;


    /**
     * Creates a new MapContextBeanInfo.
     */
    public MapContextBeanInfo() {        
                          
        mDefaultPropertyIndex = -1;
        
    }
     
    /**
     * Returns a BeanDescriptor that describes MapContext.
     */    
    public BeanDescriptor getBeanDescriptor() {
        
        if (mBeanDescriptor == null) {
            mBeanDescriptor = createBeanDescriptor();       
        }

        return mBeanDescriptor;
    }

    /**
     * Returns a BeanInfo array containing BeanInfo object's for:<br>
     * <code>java.lang.Object</code><br>      
     */  
    public BeanInfo[] getAdditionalBeanInfo() {

        if (mAdditionalBeanInfo == null) {
            mAdditionalBeanInfo = createAdditionalBeanInfo();       
        }

        return mAdditionalBeanInfo;
    }

    /**    
     * Returns MethodDescriptors that describe the methods of 
     * MapContext.  Call the 
     * <code>getAdditionalBeanInfo</code> method to get the 
     * method descriptors of the superclass and interfaces.
     */ 
    public MethodDescriptor[] getMethodDescriptors() {

        if (mMethodDescriptors == null) {
            mMethodDescriptors = createMethodDescriptors();       
        }

        return mMethodDescriptors;
    }

    /**    
     * Returns a PropertyDescriptor array that describes the properties of 
     * MapContext.
     */ 
    public PropertyDescriptor[] getPropertyDescriptors() {

        if (mPropertyDescriptors == null) {
            mPropertyDescriptors = createPropertyDescriptors();     
        }

        return mPropertyDescriptors;
    }

    /**
     * Return the index of the default property.
     */
    public int getDefaultPropertyIndex() {
        return mDefaultPropertyIndex;
    }


    //
    // Non-public interface
    //

    // Create the bean descriptor for the bean.
    private BeanDescriptor createBeanDescriptor() {                        
        
        BeanDescriptor bd = 
            new BeanDescriptor(MapContext.class);
        
        bd.setName("MapContext");
        bd.setDisplayName("MapContext");
        bd.setShortDescription("");        
        bd.setValue("BeanDoc", "4.1.2");
        
        return bd;
    }

    // Create the additional bean info objects for the bean.
    private BeanInfo[] createAdditionalBeanInfo() {
        
        Vector bis = new Vector();
        BeanInfo bi = null;                
        
        bi = null;
        try {
            // Get the BeanInfo for the superclass
            bi = Introspector.getBeanInfo(java.lang.Object.class);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }        
        
        if (bi != null) {    
            bis.addElement(bi);
        }                            
                        
        BeanInfo[] additionalBeanInfo = null;
        if (bis.size() > 0) {
            additionalBeanInfo = new BeanInfo[bis.size()];
            bis.copyInto(additionalBeanInfo);
        }
        
        return additionalBeanInfo;
    }

    // Create the method descriptor objects for the bean.
    private MethodDescriptor[] createMethodDescriptors() {
                
        Class[] paramTypes = null;
        int paramIndex = 0;  
        ParameterDescriptor[] paramDescriptors = null;
        ParameterDescriptor pd = null;
        
        Vector mds = new Vector();
        Method m = null;
        MethodDescriptor md = null;

           
        
        //
        // clear 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("clear", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("clear");
            md.setDisplayName("clear");  
            
            mds.addElement(md);
        }            
           
        
        //
        // containsKey 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("key");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("containsKey", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("containsKey");
            md.setDisplayName("containsKey");  
            
            mds.addElement(md);
        }            
           
        
        //
        // containsValue 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("value");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("containsValue", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("containsValue");
            md.setDisplayName("containsValue");  
            
            mds.addElement(md);
        }            
           
        
        //
        // createHashMap 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = MapContext.class.getMethod("createHashMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createHashMap");
            md.setDisplayName("createHashMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // createPropertyMap 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = MapContext.class.getMethod("createPropertyMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPropertyMap");
            md.setDisplayName("createPropertyMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // createPropertyMap 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("createPropertyMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPropertyMap");
            md.setDisplayName("createPropertyMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // createPropertyMap 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("seperator");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("createPropertyMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createPropertyMap");
            md.setDisplayName("createPropertyMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // createSortedMap 
        //
        paramTypes = new Class[0];
        paramDescriptors = new ParameterDescriptor[0];
        paramIndex = 0;        
                
        m = null;
        try {
            m = MapContext.class.getMethod("createSortedMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("createSortedMap");
            md.setDisplayName("createSortedMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // entrySet 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("entrySet", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("entrySet");
            md.setDisplayName("entrySet");  
            
            mds.addElement(md);
        }            
           
        
        //
        // firstKey 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.SortedMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.SortedMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("firstKey", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("firstKey");
            md.setDisplayName("firstKey");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getKeys 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("getKeys", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getKeys");
            md.setDisplayName("getKeys");  
            
            mds.addElement(md);
        }            
           
        
        //
        // getKeysAsStrings 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("getKeysAsStrings", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("getKeysAsStrings");
            md.setDisplayName("getKeysAsStrings");  
            
            mds.addElement(md);
        }            
           
        
        //
        // headMap 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.SortedMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.SortedMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("toKey");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("headMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("headMap");
            md.setDisplayName("headMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // keySet 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("keySet", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("keySet");
            md.setDisplayName("keySet");  
            
            mds.addElement(md);
        }            
           
        
        //
        // lastKey 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.SortedMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.SortedMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("lastKey", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("lastKey");
            md.setDisplayName("lastKey");  
            
            mds.addElement(md);
        }            
           
        
        //
        // put 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("key");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("value");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("put", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("put");
            md.setDisplayName("put");  
            
            mds.addElement(md);
        }            
           
        
        //
        // putAll 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("mapToAddTo");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("mapToAdd");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("putAll", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("putAll");
            md.setDisplayName("putAll");  
            
            mds.addElement(md);
        }            
           
        
        //
        // remove 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("key");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("remove", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("remove");
            md.setDisplayName("remove");  
            
            mds.addElement(md);
        }            
           
        
        //
        // size 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("size", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("size");
            md.setDisplayName("size");  
            
            mds.addElement(md);
        }            
           
        
        //
        // subMap 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.trove.util.PropertyMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("org.teatrove.trove.util.PropertyMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.String.class; 
        pd = new ParameterDescriptor();
        pd.setName("name");
        pd.setDisplayName("java.lang.String"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("subMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("subMap");
            md.setDisplayName("subMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // subMap 
        //
        paramTypes = new Class[3];
        paramDescriptors = new ParameterDescriptor[3];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.SortedMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.SortedMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("fromKey");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("toKey");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("subMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("subMap");
            md.setDisplayName("subMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // subMapKeysAsStrings 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.trove.util.PropertyMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("org.teatrove.trove.util.PropertyMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("subMapKeysAsStrings", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("subMapKeysAsStrings");
            md.setDisplayName("subMapKeysAsStrings");  
            
            mds.addElement(md);
        }            
           
        
        //
        // subMapKeySet 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = org.teatrove.trove.util.PropertyMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("org.teatrove.trove.util.PropertyMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("subMapKeySet", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("subMapKeySet");
            md.setDisplayName("subMapKeySet");  
            
            mds.addElement(md);
        }            
           
        
        //
        // tailMap 
        //
        paramTypes = new Class[2];
        paramDescriptors = new ParameterDescriptor[2];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.SortedMap.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.SortedMap"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                        
        paramTypes[paramIndex] = java.lang.Object.class; 
        pd = new ParameterDescriptor();
        pd.setName("fromKey");
        pd.setDisplayName("java.lang.Object"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("tailMap", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("tailMap");
            md.setDisplayName("tailMap");  
            
            mds.addElement(md);
        }            
           
        
        //
        // values 
        //
        paramTypes = new Class[1];
        paramDescriptors = new ParameterDescriptor[1];
        paramIndex = 0;        
                        
        paramTypes[paramIndex] = java.util.Map.class; 
        pd = new ParameterDescriptor();
        pd.setName("map");
        pd.setDisplayName("java.util.Map"); 
        paramDescriptors[paramIndex] = pd;        
        paramIndex++;
                
        m = null;
        try {
            m = MapContext.class.getMethod("values", paramTypes);
        }
        catch (Throwable t) {
            t.printStackTrace();
        }
        
        if (m != null) {
          
            md = null;
                    
            if (paramDescriptors != null) {
                md = new MethodDescriptor(m, paramDescriptors);
            }
            else {
                md = new MethodDescriptor(m);    
            }
            
            md.setName("values");
            md.setDisplayName("values");  
            
            mds.addElement(md);
        }            
               
                         
        MethodDescriptor[] methodDescriptors = 
                                new MethodDescriptor[mds.size()];
        mds.copyInto(methodDescriptors);
                
        return methodDescriptors;
    }

    // Create the property descriptor objects for the bean.
    private PropertyDescriptor[] createPropertyDescriptors() {
                           
        PropertyDescriptor[] propertyDescriptors = new PropertyDescriptor[0];
        PropertyDescriptor pd = null;
        int propertyIndex = 0;          
        
        if (propertyDescriptors.length == 0) {
            propertyDescriptors = null;    
        }
        
        return propertyDescriptors;
    }

}